select
    an.numero
    , cpt1.producaototal as Primeira_lact --Lact
    , cpt1.diaslactacao  as Primeira_dias --Dias
    , (case when cpt1.producaototal is not null and cpt1.diaslactacao > 0 then (cpt1.producaototal / cpt1.diaslactacao) else null end) as Primeira_media --Mdia
--
    , cpt2.producaototal as Segunda_lact --Lact
    , cpt2.diaslactacao  as Segunda_dias --Dias
    , (case when cpt2.producaototal is not null and cpt2.diaslactacao > 0 then (cpt2.producaototal / cpt2.diaslactacao) else null end) as Segunda_media --Mdia
--
    , cpt3.producaototal as Terceira_lact --Lact
    , cpt3.diaslactacao  as Terceira_dias --Dias
    , (case when cpt3.producaototal is not null and cpt3.diaslactacao > 0 then (cpt3.producaototal / cpt3.diaslactacao) else null end) as Terceira_media --Mdia
--
    , cpt4.producaototal as Quarta_lact --Lact
    , cpt4.diaslactacao  as Quarta_dias --Dias
    , (case when cpt4.producaototal is not null and cpt4.diaslactacao > 0 then (cpt4.producaototal / cpt4.diaslactacao) else null end) as Quarta_media --Mdia
--
    , cpt5.producaototal as Quinta_lact --Lact
    , cpt5.diaslactacao  as Quinta_dias --Dias
    , (case when cpt5.producaototal is not null and cpt5.diaslactacao > 0 then (cpt5.producaototal / cpt5.diaslactacao) else null end) as Quinta_media --Mdia
--
    , cpt6.producaototal as Sexta_lact --Lact
    , cpt6.diaslactacao  as Sexta_dias --Dias
    , (case when cpt6.producaototal is not null and cpt6.diaslactacao > 0 then (cpt6.producaototal / cpt6.diaslactacao) else null end) as Sexta_media --Mdia
--
    , cpt7.producaototal as Setima_lact --Lact
    , cpt7.diaslactacao  as Setima_dias --Dias
    , (case when cpt7.producaototal is not null and cpt7.diaslactacao > 0 then (cpt7.producaototal / cpt7.diaslactacao) else null end) as Setima_media --Mdia
--
    , cpt8.producaototal as Oitava_lact --Lact
    , cpt8.diaslactacao  as Oitava_dias --Dias
    , (case when cpt8.producaototal is not null and cpt8.diaslactacao > 0 then (cpt8.producaototal / cpt8.diaslactacao) else null end) as Oitava_media --Mdia
--
    , cpt9.producaototal as Nona_lact --Lact
    , cpt9.diaslactacao  as Nona_dias --Dias
    , (case when cpt9.producaototal is not null and cpt9.diaslactacao > 0 then (cpt9.producaototal / cpt9.diaslactacao) else null end) as Nona_media --Mdia
--
    , cpt10.producaototal as Decima_lact --Lact
    , cpt10.diaslactacao  as Decima_dias --Dias
    , (case when cpt10.producaototal is not null and cpt10.diaslactacao > 0 then (cpt10.producaototal / cpt10.diaslactacao) else null end) as Decima_media --Mdia
--
    , (case when cpt1.diaslactacao > 0 then (cpt1.producaototal + coalesce (cpt2.producaototal,0) + coalesce (cpt3.producaototal,0) + coalesce (cpt4.producaototal,0) + coalesce (cpt5.producaototal,0) + coalesce (cpt6.producaototal,0) + coalesce (cpt7.producaototal,0) + coalesce (cpt8.producaototal,0) + coalesce (cpt9.producaototal,0) + coalesce (cpt10.producaototal,0)) else null end) as total_lact
    , (case when cpt1.diaslactacao > 0 then (cpt1.diaslactacao + coalesce (cpt2.diaslactacao,0) + coalesce (cpt3.diaslactacao,0) + coalesce (cpt4.diaslactacao,0) + coalesce (cpt5.diaslactacao,0) + coalesce (cpt6.diaslactacao,0) + coalesce (cpt7.diaslactacao,0) + coalesce (cpt8.diaslactacao,0) + coalesce (cpt9.diaslactacao,0) + coalesce (cpt10.diaslactacao,0)) else null end) as total_dias
    , (case when cpt1.diaslactacao > 0 then (cpt1.producaototal + coalesce (cpt2.producaototal,0) + coalesce (cpt3.producaototal,0) + coalesce (cpt4.producaototal,0) + coalesce (cpt5.producaototal,0) + coalesce (cpt8.producaototal,0) + coalesce (cpt7.producaototal,0) + coalesce (cpt8.producaototal,0) + coalesce (cpt9.producaototal,0) + coalesce (cpt10.producaototal,0))/
        (cpt1.diaslactacao + coalesce (cpt2.diaslactacao,0) + coalesce (cpt3.diaslactacao,0) + coalesce (cpt4.diaslactacao,0) + coalesce (cpt5.diaslactacao,0) + coalesce (cpt6.diaslactacao,0) + coalesce (cpt7.diaslactacao,0) + coalesce (cpt8.diaslactacao,0) + coalesce (cpt9.diaslactacao,0) + coalesce (cpt10.diaslactacao,0)) else null end) as total_media

from
    animal an
    join lactacao lac1 on lac1.cdlactacao =
        (select first 1 re.cdlactacao from lactacao re where re.cdanimal = an.cdanimal order by re.dtinicio asc)
    left join sp_calculaproducaototal(lac1.cdlactacao,(coalesce(lac1.dtfim, an.dtbaixa, current_date))) cpt1 on lac1.cdlactacao is not null
--
    left join lactacao lac2 on lac2.cdlactacao =
        (select first 1 re.cdlactacao from lactacao re where re.cdanimal = an.cdanimal and re.dtinicio > lac1.dtinicio order by re.dtinicio asc)
    left join sp_calculaproducaototal(lac2.cdlactacao,(coalesce(lac2.dtfim, an.dtbaixa, current_date))) cpt2 on lac2.cdlactacao is not null
--
    left join lactacao lac3 on lac3.cdlactacao =
        (select first 1 re.cdlactacao from lactacao re where re.cdanimal = an.cdanimal and re.dtinicio > lac2.dtinicio order by re.dtinicio asc)
    left join sp_calculaproducaototal(lac3.cdlactacao,(coalesce(lac3.dtfim, an.dtbaixa, current_date))) cpt3 on lac3.cdlactacao is not null
--
    left join lactacao lac4 on lac4.cdlactacao =
        (select first 1 re.cdlactacao from lactacao re where re.cdanimal = an.cdanimal and re.dtinicio > lac3.dtinicio order by re.dtinicio asc)
    left join sp_calculaproducaototal(lac4.cdlactacao,(coalesce(lac4.dtfim, an.dtbaixa, current_date))) cpt4 on lac4.cdlactacao is not null
--
    left join lactacao lac5 on lac5.cdlactacao =
        (select first 1 re.cdlactacao from lactacao re where re.cdanimal = an.cdanimal and re.dtinicio > lac4.dtinicio order by re.dtinicio asc)
    left join sp_calculaproducaototal(lac5.cdlactacao,(coalesce(lac5.dtfim, an.dtbaixa, current_date))) cpt5 on lac5.cdlactacao is not null
--
    left join lactacao lac6 on lac6.cdlactacao =
        (select first 1 re.cdlactacao from lactacao re where re.cdanimal = an.cdanimal and re.dtinicio > lac5.dtinicio order by re.dtinicio asc)
    left join sp_calculaproducaototal(lac6.cdlactacao,(coalesce(lac6.dtfim, an.dtbaixa, current_date))) cpt6 on lac6.cdlactacao is not null
--
    left join lactacao lac7 on lac7.cdlactacao =
        (select first 1 re.cdlactacao from lactacao re where re.cdanimal = an.cdanimal and re.dtinicio > lac6.dtinicio order by re.dtinicio asc)
    left join sp_calculaproducaototal(lac7.cdlactacao,(coalesce(lac7.dtfim, an.dtbaixa, current_date))) cpt7 on lac7.cdlactacao is not null
--
    left join lactacao lac8 on lac8.cdlactacao =
        (select first 1 re.cdlactacao from lactacao re where re.cdanimal = an.cdanimal and re.dtinicio > lac7.dtinicio order by re.dtinicio asc)
    left join sp_calculaproducaototal(lac8.cdlactacao,(coalesce(lac8.dtfim, an.dtbaixa, current_date))) cpt8 on lac8.cdlactacao is not null
--
    left join lactacao lac9 on lac9.cdlactacao =
        (select first 1 re.cdlactacao from lactacao re where re.cdanimal = an.cdanimal and re.dtinicio > lac8.dtinicio order by re.dtinicio asc)
    left join sp_calculaproducaototal(lac9.cdlactacao,(coalesce(lac9.dtfim, an.dtbaixa, current_date))) cpt9 on lac9.cdlactacao is not null
--
    left join lactacao lac10 on lac10.cdlactacao =
        (select first 1 re.cdlactacao from lactacao re where re.cdanimal = an.cdanimal and re.dtinicio > lac9.dtinicio order by re.dtinicio asc)
    left join sp_calculaproducaototal(lac10.cdlactacao,(coalesce(lac10.dtfim, an.dtbaixa, current_date))) cpt10 on lac10.cdlactacao is not null
where
    an.sexo = 'F'
    and an.tipoanimal = 'A'
order by an.numordenado
